/*
 * II Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 3-4.XII.2004
 *
 * Program sprawdzajacy do zadania B - Wagi grafu
 * Zlozonosc: O(N^2)
 *
 * Autor programu: Bartosz Nowierski
 */

#include <stdio.h>
#include <string.h>
/*#define NDEBUG*/
#include <assert.h>
#define VERBOSE

#define MAXD 50

#define MAXN 400


int N;
int D[3*MAXN];
int G[MAXN][MAXN];


int main(int argc, char *argv[])
{
  int d;
  FILE *fin, *fout;
  char str[5];
  int sum;
  int i, j;


  fin = fopen(argv[1], "r");
  fout = fopen(argv[3], "r");
  assert(NULL != fin);
  assert(NULL != fout);

  
  if (fscanf(fin, "%d", &d) < 1)
    assert(0);
  assert((d > 0) && (d <= MAXD));
  while (d--)
  {
    if (fscanf(fin, "%d", &N) < 1)
      assert(0);
    assert((N >= 2) && (N <= MAXN));

    if (2 == N)
    {
      if (fscanf(fout, "%5s", str) < 1)
      {
#ifdef VERBOSE
        printf("read error (1)\n");
#endif
        goto WRONG_ANSWER;
      }
      if (strcmp("NIE", str) != 0)
      {
#ifdef VERBOSE
        printf("the answer should be \"NIE\"\n");
#endif
        goto WRONG_ANSWER;
      }
      continue;
    }

    for (i = N-1; i <= 3*(N-1); i++)
      D[i] = 0;
      
    for (i = 0; i < N; i++)
    {
      sum = 0;
      for (j = 0; j < N; j++)
      {
        if (fscanf(fout, "%d", &G[i][j]) < 1)
        {
#ifdef VERBOSE
          printf("read error (2)\n");
#endif
          goto WRONG_ANSWER;
        }
        if ((i == j) && (G[i][j] != 0))
        {
#ifdef VERBOSE
          printf("weight on diagonal is not 0\n");
#endif
          goto WRONG_ANSWER;
        }
        if ((i != j) && ((G[i][j] < 1) || (G[i][j] > 3)))
        {
#ifdef VERBOSE
          printf("weight is not between 1 and 3\n");
#endif
          goto WRONG_ANSWER;
        }
        if ((j < i) && (G[i][j] != G[j][i]))
        {
#ifdef VERBOSE
          printf("graph is not symmetric\n");
#endif
          goto WRONG_ANSWER;
        }
        sum += G[i][j];
      }
      assert((sum >= N-1) && (sum <= 3*(N-1)));
      if (D[sum])
      {
#ifdef VERBOSE
        printf("degrees are not unique\n");
#endif
        goto WRONG_ANSWER;
      }
      D[sum] = 1;
    }
  }
  
  fclose(fin);
  fclose(fout);
#ifdef VERBOSE
  printf("ACCEPTED\n");
#endif
  return 0;
  
  fclose(fin);
  fclose(fout);
  WRONG_ANSWER:
#ifdef VERBOSE
  printf("WRONG ANSWER\n");
#endif
  
  return 3;
}

